"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigHandler = require("./nodes/config-node");
const semver = require("semver");
const InputNodeHandler = require("./nodes/input-node");
const ReadNodeHandler = require("./nodes/read-node");
const WriteNodeHandler = require("./nodes/write-node");
var module;
function checkVersion(RED) {
    var minNodeJsRequired = 'v4.4.5';
    if (semver.lt(process.version, minNodeJsRequired)) {
        RED.log.warn('The Opto 22 PAC nodes require Node.js ' + minNodeJsRequired + ' or greater.');
    }
}
module.exports = function (RED) {
    checkVersion(RED);
    InputNodeHandler.setRED(RED);
    ReadNodeHandler.setRED(RED);
    WriteNodeHandler.setRED(RED);
    ConfigHandler.setRED(RED);
    RED.nodes.registerType(InputNodeHandler.InputNodeImpl.getNodeType(), InputNodeHandler.createInputNode);
    RED.nodes.registerType(ReadNodeHandler.ReadNodeImpl.getNodeType(), ReadNodeHandler.createReadNode);
    RED.nodes.registerType(WriteNodeHandler.WriteNodeImpl.getNodeType(), WriteNodeHandler.createWriteNode);
    RED.nodes.registerType(ConfigHandler.GroovIoDeviceNodeType, ConfigHandler.createDeviceNode, {
        credentials: {
            apiKey: { type: "password" },
            publicCertPath: { type: "text" },
            caCertPath: { type: "text" }
        }
    });
};
