"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const localVarRequest = require("request");
const https = require("https");
const Promise = require("bluebird");
let defaultBasePath = 'https://localhost/manage';
class AbstractChannelRead {
}
exports.AbstractChannelRead = AbstractChannelRead;
class AbstractMmpValues {
}
exports.AbstractMmpValues = AbstractMmpValues;
class AnalogModuleValues {
}
exports.AnalogModuleValues = AnalogModuleValues;
class AnalogModuleValuesChannelValues {
}
exports.AnalogModuleValuesChannelValues = AnalogModuleValuesChannelValues;
class BooleanValue {
}
exports.BooleanValue = BooleanValue;
class ChannelConfig {
}
exports.ChannelConfig = ChannelConfig;
class ChannelConfigWrite {
}
exports.ChannelConfigWrite = ChannelConfigWrite;
class ChannelDescription {
}
exports.ChannelDescription = ChannelDescription;
class ChannelDescriptions extends null {
}
exports.ChannelDescriptions = ChannelDescriptions;
class ChannelNames {
}
exports.ChannelNames = ChannelNames;
class DigitalModuleValues {
}
exports.DigitalModuleValues = DigitalModuleValues;
class DigitalModuleValuesChannelValues {
}
exports.DigitalModuleValuesChannelValues = DigitalModuleValuesChannelValues;
class FileAreaType {
}
exports.FileAreaType = FileAreaType;
class FileDetailsArray extends Array {
}
exports.FileDetailsArray = FileDetailsArray;
class FileDetailsModel {
}
exports.FileDetailsModel = FileDetailsModel;
class I18nString {
}
exports.I18nString = I18nString;
class InlineResponse200 {
}
exports.InlineResponse200 = InlineResponse200;
class IoConfiguration {
}
exports.IoConfiguration = IoConfiguration;
class IoFirmare {
}
exports.IoFirmare = IoFirmare;
class IoHardware {
}
exports.IoHardware = IoHardware;
class IoInfo {
}
exports.IoInfo = IoInfo;
class MmpGenericValues {
}
exports.MmpGenericValues = MmpGenericValues;
class MmpGenericValuesValues {
}
exports.MmpGenericValuesValues = MmpGenericValuesValues;
class MmpNumericValue {
}
exports.MmpNumericValue = MmpNumericValue;
class MmpValueType {
}
exports.MmpValueType = MmpValueType;
class ModuleChannelConfig {
}
exports.ModuleChannelConfig = ModuleChannelConfig;
class ModuleChannelDescriptions {
}
exports.ModuleChannelDescriptions = ModuleChannelDescriptions;
class ModuleDescription {
}
exports.ModuleDescription = ModuleDescription;
class ModuleDescriptions extends null {
}
exports.ModuleDescriptions = ModuleDescriptions;
class ModuleInfo {
}
exports.ModuleInfo = ModuleInfo;
class ModuleQualityFlags {
}
exports.ModuleQualityFlags = ModuleQualityFlags;
class ModuleType {
}
exports.ModuleType = ModuleType;
class ModuleTypes {
}
exports.ModuleTypes = ModuleTypes;
class NumericValue {
}
exports.NumericValue = NumericValue;
class RequestError {
}
exports.RequestError = RequestError;
class RequestErrorDetail {
}
exports.RequestErrorDetail = RequestErrorDetail;
class ResponseError {
}
exports.ResponseError = ResponseError;
class ResponseErrorDetail {
}
exports.ResponseErrorDetail = ResponseErrorDetail;
class ValidationError {
}
exports.ValidationError = ValidationError;
class ValidationErrorDetail {
}
exports.ValidationErrorDetail = ValidationErrorDetail;
class AnalogChannelRead extends AbstractChannelRead {
}
exports.AnalogChannelRead = AnalogChannelRead;
class DigitalChannelRead extends AbstractChannelRead {
}
exports.DigitalChannelRead = DigitalChannelRead;
class MmpNumericValues extends AbstractMmpValues {
}
exports.MmpNumericValues = MmpNumericValues;
class MmpStringValues extends AbstractMmpValues {
}
exports.MmpStringValues = MmpStringValues;
var DefaultApiApiKeys;
(function (DefaultApiApiKeys) {
    DefaultApiApiKeys[DefaultApiApiKeys["apiKey"] = 0] = "apiKey";
})(DefaultApiApiKeys = exports.DefaultApiApiKeys || (exports.DefaultApiApiKeys = {}));
class DefaultApi {
    constructor(address, apiKey, publicCertFile, caCertFile) {
        this._basePath = defaultBasePath;
        this.defaultHeaders = {};
        this._useQuerystring = false;
        this.httpsAgent = new https.Agent({
            keepAlive: true,
            maxSockets: 1,
        });
        this.authentications = {};
        this.address = address;
        this._basePath = 'https://' + address + '/manage';
        this.apiKey = apiKey;
        this.publicCertFile = publicCertFile;
        this.caCertFile = caCertFile;
        if (address === 'localhost') {
            this.isLocalhost = true;
        }
        this.defaultHeaders['apiKey'] = this.apiKey;
    }
    ;
    set useQuerystring(value) {
        this._useQuerystring = value;
    }
    set basePath(basePath) {
        this._basePath = basePath;
    }
    get basePath() {
        return this._basePath;
    }
    addFile(area, fileName, file, options = {}) {
        const localVarPath = this.basePath + '/api/v1/files/{area}/content/{fileName}'
            .replace('{' + 'area' + '}', encodeURIComponent(String(area)))
            .replace('{' + 'fileName' + '}', encodeURIComponent(String(fileName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (area === null || area === undefined) {
            throw new Error('Required parameter area was null or undefined when calling addFile.');
        }
        if (fileName === null || fileName === undefined) {
            throw new Error('Required parameter fileName was null or undefined when calling addFile.');
        }
        if (file === null || file === undefined) {
            throw new Error('Required parameter file was null or undefined when calling addFile.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        if (file !== undefined) {
            localVarFormParams['file'] = file;
        }
        localVarUseFormData = true;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    clearAnalogChannelMaxValue(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/analog/max-value/clear'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling clearAnalogChannelMaxValue.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling clearAnalogChannelMaxValue.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling clearAnalogChannelMaxValue.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    clearAnalogChannelMinValue(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/analog/min-value/clear'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling clearAnalogChannelMinValue.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling clearAnalogChannelMinValue.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling clearAnalogChannelMinValue.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    clearDigitalChannelFeature(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/feature/clear'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling clearDigitalChannelFeature.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling clearDigitalChannelFeature.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling clearDigitalChannelFeature.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    clearDigitalChannelOffLatch(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/off-latch/clear'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling clearDigitalChannelOffLatch.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling clearDigitalChannelOffLatch.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling clearDigitalChannelOffLatch.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    clearDigitalChannelOnLatch(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/on-latch/clear'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling clearDigitalChannelOnLatch.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling clearDigitalChannelOnLatch.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling clearDigitalChannelOnLatch.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    deleteFile(area, fileName, options = {}) {
        const localVarPath = this.basePath + '/api/v1/files/{area}/content/{fileName}'
            .replace('{' + 'area' + '}', encodeURIComponent(String(area)))
            .replace('{' + 'fileName' + '}', encodeURIComponent(String(fileName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (area === null || area === undefined) {
            throw new Error('Required parameter area was null or undefined when calling deleteFile.');
        }
        if (fileName === null || fileName === undefined) {
            throw new Error('Required parameter fileName was null or undefined when calling deleteFile.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelAnalogStatus(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/analog/status'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getChannelAnalogStatus.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getChannelAnalogStatus.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling getChannelAnalogStatus.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelConfiguration(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/config'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getChannelConfiguration.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getChannelConfiguration.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling getChannelConfiguration.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelDescription(channelId, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/descriptions/channels/{channelId}'
            .replace('{' + 'channelId' + '}', encodeURIComponent(String(channelId)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (channelId === null || channelId === undefined) {
            throw new Error('Required parameter channelId was null or undefined when calling getChannelDescription.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelDescriptions(options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/descriptions/channels';
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelDigitalStatus(device, moduleIndex, channelIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/status'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getChannelDigitalStatus.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getChannelDigitalStatus.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling getChannelDigitalStatus.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getChannelNames(device, moduleIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/names'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getChannelNames.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getChannelNames.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getFile(area, fileName, options = {}) {
        const localVarPath = this.basePath + '/api/v1/files/{area}/content/{fileName}'
            .replace('{' + 'area' + '}', encodeURIComponent(String(area)))
            .replace('{' + 'fileName' + '}', encodeURIComponent(String(fileName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (area === null || area === undefined) {
            throw new Error('Required parameter area was null or undefined when calling getFile.');
        }
        if (fileName === null || fileName === undefined) {
            throw new Error('Required parameter fileName was null or undefined when calling getFile.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getFileInfo(area, fileName, options = {}) {
        const localVarPath = this.basePath + '/api/v1/files/{area}/info/{fileName}'
            .replace('{' + 'area' + '}', encodeURIComponent(String(area)))
            .replace('{' + 'fileName' + '}', encodeURIComponent(String(fileName)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (area === null || area === undefined) {
            throw new Error('Required parameter area was null or undefined when calling getFileInfo.');
        }
        if (fileName === null || fileName === undefined) {
            throw new Error('Required parameter fileName was null or undefined when calling getFileInfo.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getFiles(area, options = {}) {
        const localVarPath = this.basePath + '/api/v1/files/{area}/info'
            .replace('{' + 'area' + '}', encodeURIComponent(String(area)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (area === null || area === undefined) {
            throw new Error('Required parameter area was null or undefined when calling getFiles.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getIoConfiguration(device, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/config'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getIoConfiguration.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getIoInfo(device, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/info'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getIoInfo.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getMmpValues(device, address, type, length, encoding, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/mmp/address/{address}'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'address' + '}', encodeURIComponent(String(address)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getMmpValues.');
        }
        if (address === null || address === undefined) {
            throw new Error('Required parameter address was null or undefined when calling getMmpValues.');
        }
        if (type !== undefined) {
            localVarQueryParameters['type'] = type;
        }
        if (length !== undefined) {
            localVarQueryParameters['length'] = length;
        }
        if (encoding !== undefined) {
            localVarQueryParameters['encoding'] = encoding;
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleAnalogChannelValues(device, moduleIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/analog/values'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleAnalogChannelValues.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getModuleAnalogChannelValues.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleConfiguration(device, moduleIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/config'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleConfiguration.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getModuleConfiguration.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleDescription(module, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/descriptions/modules/{module}'
            .replace('{' + 'module' + '}', encodeURIComponent(String(module)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (module === null || module === undefined) {
            throw new Error('Required parameter module was null or undefined when calling getModuleDescription.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleDescriptions(options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/descriptions/modules';
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleDigitalChannelValues(device, moduleIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/digital/values'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleDigitalChannelValues.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getModuleDigitalChannelValues.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleInfo(device, moduleIndex, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/info'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleInfo.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling getModuleInfo.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleInfos(device, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/info'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleInfos.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleQualityFlags(device, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/quality'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleQualityFlags.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    getModuleTypes(device, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/type'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling getModuleTypes.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setAnalogChannelValue(device, moduleIndex, channelIndex, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/analog/value'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setAnalogChannelValue.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling setAnalogChannelValue.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling setAnalogChannelValue.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setAnalogChannelValue.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setChannelConfiguration(device, moduleIndex, channelIndex, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/config'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setChannelConfiguration.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling setChannelConfiguration.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling setChannelConfiguration.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setChannelConfiguration.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setDigitalChannelCounterActive(device, moduleIndex, channelIndex, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/counter/active'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setDigitalChannelCounterActive.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling setDigitalChannelCounterActive.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling setDigitalChannelCounterActive.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setDigitalChannelCounterActive.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setDigitalChannelState(device, moduleIndex, channelIndex, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/modules/{moduleIndex}/channels/{channelIndex}/digital/state'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'moduleIndex' + '}', encodeURIComponent(String(moduleIndex)))
            .replace('{' + 'channelIndex' + '}', encodeURIComponent(String(channelIndex)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setDigitalChannelState.');
        }
        if (moduleIndex === null || moduleIndex === undefined) {
            throw new Error('Required parameter moduleIndex was null or undefined when calling setDigitalChannelState.');
        }
        if (channelIndex === null || channelIndex === undefined) {
            throw new Error('Required parameter channelIndex was null or undefined when calling setDigitalChannelState.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setDigitalChannelState.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setIoConfiguration(device, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/config'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setIoConfiguration.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setIoConfiguration.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setIoConfigurationOpCode(device, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/config/opcode'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setIoConfigurationOpCode.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setIoConfigurationOpCode.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setMmpValue(device, address, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/mmp/address/{address}'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)))
            .replace('{' + 'address' + '}', encodeURIComponent(String(address)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setMmpValue.');
        }
        if (address === null || address === undefined) {
            throw new Error('Required parameter address was null or undefined when calling setMmpValue.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setMmpValue.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    setMmpValues(device, body, options = {}) {
        const localVarPath = this.basePath + '/api/v1/io/{device}/mmp/address'
            .replace('{' + 'device' + '}', encodeURIComponent(String(device)));
        let localVarQueryParameters = {};
        let localVarHeaderParams = Object.assign({}, this.defaultHeaders);
        let localVarFormParams = {};
        if (device === null || device === undefined) {
            throw new Error('Required parameter device was null or undefined when calling setMmpValues.');
        }
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling setMmpValues.');
        }
        Object.assign(localVarHeaderParams, options.headers);
        let localVarUseFormData = false;
        let localVarRequestOptions = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: body
        };
        if (this.publicCertFile) {
            localVarRequestOptions.cert = this.publicCertFile;
        }
        if (this.caCertFile) {
            localVarRequestOptions.ca = this.caCertFile;
        }
        if (!this.publicCertFile && !this.caCertFile && this.isLocalhost) {
            localVarRequestOptions.rejectUnauthorized = false;
        }
        localVarRequestOptions.forever = true;
        localVarRequestOptions.agent = this.httpsAgent;
        localVarRequestOptions.timeout = 15000;
        if (Object.keys(localVarFormParams).length) {
            if (localVarUseFormData) {
                localVarRequestOptions.formData = localVarFormParams;
            }
            else {
                localVarRequestOptions.form = localVarFormParams;
            }
        }
        return new Promise((resolve, reject) => {
            localVarRequest(localVarRequestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                }
                else {
                    if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    }
                    else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
exports.DefaultApi = DefaultApi;
